package com.ggj_linlithgow.gdx.core;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.utils.Logger;
import com.ggj_linlithgow.gdx.core.battle_state.BattleState;
import com.ggj_linlithgow.gdx.core.deploy_state.DeployState;
import com.ggj_linlithgow.gdx.core.map_state.MapState;
import com.ggj_linlithgow.gdx.core.menu_state.MenuState;
import com.ggj_linlithgow.gdx.core.model.Campaign;

public class Display extends Game {

	private ShapeRenderer renderer;
	public static int WIDTH = 1440, HEIGHT = 800;
	private DeployState deployState;
	private BattleState battleState;
	private MapState mapState;
	private MenuState menuState;
	
	public Campaign campaign;
	
	@Override
	public void create () {
		
		campaign = new Campaign();
		Gdx.app.setLogLevel(Logger.DEBUG);

		renderer = new ShapeRenderer();
		
		deployState = new DeployState(this);
		battleState = new BattleState(this);
		mapState = new MapState(this);
		menuState = new MenuState(this);
		
		setScreen(menuState);
	}
	
	public ShapeRenderer getRenderer() {
		return renderer;
	}
	
	public void gotoMap() {
		setScreen(mapState);
	}
	
	public void gotoDeploy() {
		setScreen(deployState);
	}
	
	public void gotoBattle() {
		setScreen(battleState);
	}
	
	public Campaign getCampaign() {
		return campaign;
	}
	
	@Override
	public void dispose() {
		super.dispose();
		battleState.dispose();
		deployState.dispose();
		mapState.dispose();
		renderer.dispose();
		Gdx.app.exit();
	}
}
