package com.ggj_linlithgow.gdx.core;

import java.util.ArrayList;
import java.util.List;

import com.ggj_linlithgow.gdx.core.model.Battle;
import com.ggj_linlithgow.gdx.core.model.BattleScores;
import com.ggj_linlithgow.gdx.core.model.Location;
import com.ggj_linlithgow.gdx.core.model.Round;
import com.ggj_linlithgow.gdx.core.model.Unit;
import com.ggj_linlithgow.gdx.core.model.UnitType;


public class MRScratchPad {

	public static void main(String[] args) {
		
		new MRScratchPad().generateStats();
	}
	
	public void generateStats() {
			
		int currentRound = 0;
		int safetyNet = 5000;
		
		List<Unit> badGuys = new ArrayList<Unit>();
		badGuys.add(new Unit(UnitType.CAVALRY, "", 10));
		badGuys.add(new Unit(UnitType.ARCHER, "", 10));
		badGuys.add(new Unit(UnitType.ARCHER, "", 10));
		badGuys.add(new Unit(UnitType.INFANTRY, "", 10));
		
		List<Unit> goodGuys = new ArrayList<Unit>();
		goodGuys.add(new Unit(UnitType.INFANTRY, "", 4));
		goodGuys.add(new Unit(UnitType.CAVALRY, "", 10));
		goodGuys.add(new Unit(UnitType.CAVALRY, "", 10));
		goodGuys.add(new Unit(UnitType.ARCHER, "", 10));
		
//		Battle battle = new Battle(goodGuys, badGuys);
//		
//		while (!battle.isBattleComplete() && currentRound < safetyNet) {
//			battle.fight(currentRound);
//			currentRound++;;
//		}
		
		
		
		
//		for (int unitATroopCount=1; unitATroopCount <= unitSize; unitATroopCount++) {
//			for (int unitBTroopCount=1; unitBTroopCount <= unitSize ; unitBTroopCount++) {
//			
//				battle(new Unit(UnitType.ARCHER, "Wood Elf Archers", unitATroopCount), new Unit(UnitType.INFANTRY, "Grudgebringer Infantry", unitBTroopCount));
//			}
//		}
		
		
		
		
		
//		Round round = new Round(goodGuys, badGuys);
//		round.fight();
		
//		battle(new Unit(UnitType.INFANTRY, "", 4), new Unit(UnitType.CAVALRY, "", 10)); // should be 2
//		battle(new Unit(UnitType.CAVALRY, "", 10), new Unit(UnitType.INFANTRY, "", 4)); // should be 2
//		
//		battle(new Unit(UnitType.ARCHER, "", 4), new Unit(UnitType.INFANTRY, "", 8)); // should be 3
//		battle(new Unit(UnitType.INFANTRY, "", 8), new Unit(UnitType.ARCHER, "", 4)); // should be 3
//		
//		battle(new Unit(UnitType.ARCHER, "", 6), new Unit(UnitType.INFANTRY, "", 8)); // should be 1
//		battle(new Unit(UnitType.INFANTRY, "", 8), new Unit(UnitType.ARCHER, "", 6)); // should be 1
	}
	
	public void battle(Unit unitA, Unit unitB) {
		
		System.out.println("Round: " + unitSummary(unitA) + " VS " + unitSummary(unitB));
		Unit winningTeam = determineWinner(unitA, unitB);
		System.out.println("\tWinner: " + winningTeam.getType() + "\t\tRemaining: " + determineTroopsRemaining(winningTeam, (winningTeam == unitA) ? unitB : unitA));
		System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
	}
	
	private String unitSummary(Unit unit) {
		
		return unit.getTroopCount() + " " + unit.getType() + " (" + unit.getName() + ")";
	}
	
	private Unit determineWinner(Unit unitA, Unit unitB) {
		
		return (unitA.score(unitB) > unitB.score(unitA)) ? unitA : unitB;
	}
	
	private double determineTroopsRemaining(Unit winningTeam, Unit losingTeam) {
		
		double realScore = BattleScores.determineRealScore(winningTeam, losingTeam);
		
		if (strongTeamWon(winningTeam, losingTeam)) {
			
			return Math.ceil(winningTeam.getTroopCount() - (losingTeam.getTroopCount() * realScore));
		} else {
			
			return Math.ceil(winningTeam.getTroopCount() - (losingTeam.getTroopCount() / realScore));
		}
	}
	
	private boolean strongTeamWon(Unit winningTeam, Unit losingTeam) {
		return (winningTeam == BattleScores.determineStrongTeam(winningTeam, losingTeam));
	}
	
	private void assertEquals(double expected, double actual) {
		
		if (expected != actual) {
			throw new IllegalStateException("expected: " + expected + " but was: " + actual) ;
		}
	}
}

