package com.ggj_linlithgow.gdx.core.deploy_state;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.ggj_linlithgow.gdx.core.Display;

public class CardPlaceHolder {

	private boolean slotAvailable = true;
	private UnitCard slotCard = null;
	private float xPos, yPos;
	private Texture filler;
	
	public CardPlaceHolder(float xPos, float yPos) {
		this.xPos = xPos;
		this.yPos = yPos;
		filler = new Texture(Gdx.files.internal("image/card_holder.png"));
	}
	
	public void draw(Batch batch) {
		batch.draw(filler, xPos, (Display.HEIGHT-yPos)-200, 150, 200);
	}
	
	public void removeCardFromSlot() {
		slotAvailable = true;
		slotCard.setWidth(slotCard.getOriginWidth()/2);
		slotCard.setHeight(slotCard.getOriginHeight()/2);
		slotCard.setLockedXPos(0);
		slotCard.setLockedYPos(0);
		slotCard = null;
		
	}
	
	public void updateCardToPlaceHolderPosition(UnitCard card) {
		slotAvailable = false;
		slotCard = card;
		slotCard.setWidth(slotCard.getOriginWidth());
		slotCard.setHeight(slotCard.getOriginHeight());
		card.setLockedXPos(xPos);
		card.setLockedYPos((Display.HEIGHT-yPos)-200);
	}
	
	public boolean isSlotAvailable() {
		return slotAvailable;
	}

	public void setSlotAvailable(boolean slotAvailable) {
		this.slotAvailable = slotAvailable;
	}

	public UnitCard getSlotCard() {
		return slotCard;
	}

	public void setSlotCard(UnitCard slotCard) {
		this.slotCard = slotCard;
	}

	public float getxPos() {
		return xPos;
	}

	public float getyPos() {
		return yPos;
	}
}
