package com.ggj_linlithgow.gdx.core.deploy_state;

import java.util.ArrayList;
import java.util.List;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.ggj_linlithgow.gdx.core.model.Unit;
import com.ggj_linlithgow.gdx.core.model.UnitType;

public class LoadBattleActors {

	private List<UnitCard> unitCards = new ArrayList<UnitCard>();
	private Texture archer;
	private Texture cavalry;
	private Texture infantry;

	public LoadBattleActors(DeployState deployState, BitmapFont bitmapFont) {
		
		archer = new Texture(Gdx.files.internal("image/card_archer.png"));
		cavalry = new Texture(Gdx.files.internal("image/card_cavalry.png"));
		infantry = new Texture(Gdx.files.internal("image/card_infantry.png"));
		
		float pos = 150;
		int numArchers = 5;
		for (int i = 0; i < numArchers; i++) {
			pos += 50;
			Unit unitArcher = new Unit(UnitType.ARCHER, "", 10);
			addCard(new UnitCard(pos, 75, 150, 200, archer, this, bitmapFont, unitArcher), deployState);
		}
		
		pos = 150;
		int numCavalry = 5;
		for (int i = 0; i < numCavalry; i++) {
			pos += 50;
			Unit unitCavalry = new Unit(UnitType.CAVALRY, "", 10);
			addCard(new UnitCard(pos, 175, 150, 200, cavalry, this, bitmapFont, unitCavalry), deployState);
		}
		
		pos = 150;
		int numInfantry = 5;
		for (int i = 0; i < numInfantry; i++) {
			pos += 50;
			Unit unitInfantry = new Unit(UnitType.INFANTRY, "", 10);
			addCard(new UnitCard(pos, 275, 150, 200, infantry, this, bitmapFont, unitInfantry), deployState);
		}
		
		Gdx.app.debug("DEBUG", "Total Number Deployed: " + (numArchers + numCavalry + numInfantry));
	}
	
	public List<UnitCard> getUnitCards() {
		return unitCards;
	}
	
	private void addCard(UnitCard unitCard, DeployState display) {
		display.addActor(unitCard);
		unitCards.add(unitCard);
	}
	
	public void begin() {
		
	}
	
	public void dispose() {
		archer.dispose();
		cavalry.dispose();
		infantry.dispose();
		unitCards.clear();
	}

	public void reset() {
		for (int i = 0; i < unitCards.size(); i++) {
			if (unitCards.get(0).getUnit().getTroopCount() <= 0) {
				unitCards.remove(i);
			}
		}
		
		float pos = 150;
		for (UnitCard card : unitCards) {
			if (UnitType.ARCHER.equals(card.getUnit().getType())) {
				pos += 50;
				card.setX(pos);
				card.setY(75);
			} 
		}
		
		pos = 150;
		for (UnitCard card : unitCards) {
			if (UnitType.CAVALRY.equals(card.getUnit().getType())) {
				pos += 50;
				card.setX(pos);
				card.setY(175);
			} 
		}
		
		pos = 150;
		for (UnitCard card : unitCards) {
			if (UnitType.INFANTRY.equals(card.getUnit().getType())) {
				pos += 50;
				card.setX(pos);
				card.setY(275);
			} 
		}
		
//		unitCards.clear();
	}
}
