package com.ggj_linlithgow.gdx.core.model;

import java.util.ArrayList;
import java.util.List;

public class Battle {

	private List<Round> rounds = new ArrayList<Round>();
	public List<Unit> initialBadGuys;
	public List<Unit> initialGoodGuys;
	/** 
	 * from the deploy screen to the battle screen
	 * @param selectedUnits
	 * @param badGuys
	 */
	public void setInitalBattleState(List<Unit> selectedUnits,
			List<Unit> badGuys) {
		initialGoodGuys = selectedUnits;
		initialBadGuys = badGuys;
	}
	
	public void addRound(final Round round) {
		
		rounds.add(round);
	}
	
	public boolean fight(int currentRound) {
		
		// if the new round does not exist we need to try create it
//		if (rounds.get(currentRound) == null) {
//			
//			//TODO: this wont really work since we need to re organise the pairings of enemy to good guy using andys screen, this just matches them based on the order they survived
//			generateNewRound(getCurrentRound());
//			
//		} 
		
		rounds.get(currentRound).fight();
		
		return rounds.get(currentRound).isEnemyDefeated();
	}
	
	public boolean isBattleComplete() {
		
		if (rounds == null || rounds.size() < 1) {
			return false;
		}
		
		return rounds.get(rounds.size()-1).isEnemyDefeated() || getCurrentRound().getRemainingGoodGuys().isEmpty();
		
	}
	
	public Round getCurrentRound() {
		return rounds.get(rounds.size()-1);
	}

	public List<Unit> getAvailableGoodGuys() {
		return rounds.isEmpty() ? initialGoodGuys : getCurrentRound().getRemainingGoodGuys();
	}

	public List<Unit> getAvailableBadGuys() {
		return rounds.isEmpty() ? initialBadGuys : getCurrentRound().getRemainingBadGuys();
	}
}
