package com.ggj_linlithgow.gdx.core.model;

import java.util.ArrayList;
import java.util.List;

public class BattleScores {

	private static final List<BattleScores> scores = new ArrayList<>();
	
	UnitType homeUnit;
	UnitType enemyUnit;
	double score;
	
	static {
		scores.add(new BattleScores(UnitType.ARCHER				, UnitType.INFANTRY				, 1.0));
		scores.add(new BattleScores(UnitType.INFANTRY			, UnitType.ARCHER				, 0.7));
		
		scores.add(new BattleScores(UnitType.INFANTRY			, UnitType.CAVALRY				, 1.0));
		scores.add(new BattleScores(UnitType.CAVALRY			, UnitType.INFANTRY				, 0.5));
		
		scores.add(new BattleScores(UnitType.CAVALRY			, UnitType.ARCHER				, 1.0));
		scores.add(new BattleScores(UnitType.ARCHER				, UnitType.CAVALRY				, 0.6));
		
		scores.add(new BattleScores(UnitType.CAVALRY			, UnitType.CAVALRY				, 1.0));
		scores.add(new BattleScores(UnitType.ARCHER				, UnitType.ARCHER				, 1.0));
		scores.add(new BattleScores(UnitType.INFANTRY			, UnitType.INFANTRY				, 1.0));
	}
	
	public BattleScores(UnitType homeUnit, UnitType enemyUnit, double score) {
		this.homeUnit = homeUnit;
		this.enemyUnit = enemyUnit;
		this.score = score;
	}
	
	public UnitType getHomeUnit() {
		return homeUnit;
	}
	
	public UnitType getEnemyUnit() {
		return enemyUnit;
	}
	
	public double getScore() {
		return score;
	}
	
	public static double score(UnitType homeUnit, UnitType enemyUnit) {
		
		for (BattleScores battleScore : scores) {
			
			if (homeUnit.equals(battleScore.getHomeUnit()) && enemyUnit.equals(battleScore.getEnemyUnit())) {
				return battleScore.getScore();
			}	
		}
		
		throw new IllegalArgumentException("Could not find battle score for " + homeUnit + " ==> " + enemyUnit);
	}
	
	public static Unit determineStrongTeam(Unit unitA, Unit unitB) {
		
		if (score(unitA.getType(), unitB.getType()) == 1) {
			return unitA;
		} else {
			return unitB;
		}
	}
	
	public static double determineRealScore(Unit unitA, Unit unitB) {
		
		return Math.min(score(unitA.getType(), unitB.getType()), score(unitB.getType(), unitA.getType()));
	}
}
