package com.ggj_linlithgow.gdx.core.model;

import java.util.ArrayList;
import java.util.List;

public class Campaign {

	private final List<Location> locations = new ArrayList<>();
	private Location currentLocation;
	
	public Campaign() {
		locations.add(new Location("Hasgaard", 	   294, 114, ""));
		locations.add(new Location("Moberg", 	   503, 207, ""));
		locations.add(new Location("Krumsholar",   622, 389, ""));
		locations.add(new Location("Alfsoss",      546, 535, ""));
		locations.add(new Location("Heinabergsar", 642, 664, "")); // pronounce this :)
		locations.add(new Location("Alptanes",     887, 735, ""));
		locations.add(new Location("Lon",          980, 602, ""));
		locations.add(new Location("Bravollr",     1144, 421, ""));
		locations.add(new Location("Buoardalsa",   1319, 563, ""));
		locations.add(new Location("Sandfell",     1250, 700, ""));
	}
	
	/**
	 * Used by MapState
	 * @param location
	 */
	public void setCurrentLocation(final Location location) {
		currentLocation = location;
	}
	
	/**
	 * Used by BattleState
	 * @return
	 */
	public Location getCurrentLocation() {
		return currentLocation;
	}
	public List<Location> getLocations() {
		return locations;
	}
}
