package com.ggj_linlithgow.gdx.core.model;

public class SkirmishResult {

	Unit winner;
	Unit loser;
	Outcome outcome;
	double winningTroopsRemaining = 0;
	
	public SkirmishResult(Unit winner, Unit loser, double winningTroopsRemaining) {
	
		this.winner = winner;
		this.loser = loser;
		this.winningTroopsRemaining = winningTroopsRemaining;
		
		
		if (winner.isEnemy()) {
			outcome = Outcome.LOST;
			
		} else {
			
			if (winningTroopsRemaining < 1) { //if your team also died killing the enemy then we deem this a draw
				outcome = Outcome.DRAW;
			} else {
				outcome = Outcome.WON;
			}
		}
		
		performUnitUpdates(); // take into consideration the damage to winners and losers
	}
	
	public void performUnitUpdates() {
		
		if (loser != null) {
		    loser.setTroopCount(0);
		}
		
		if (outcome == Outcome.DRAW) {
			
			winner.setTroopCount(0); // Draw means you lost all your units and only won with your last troops dying strike.... mental eh!
		} else {
			
			winner.setTroopCount((int)winningTroopsRemaining);
		}
	}

	public Outcome getOutcome() {
		return outcome;
	}
	
	public void printReport() {
		
		System.out.println(">> " + outcome + "! " + winningTroopsRemaining + " " + ((outcome == Outcome.LOST) ? "ENEMY " : "") + winner.getType().getName() + " survived");
	}
}
