package com.ggj_linlithgow.gdx.core.model;


public class Unit {

	private UnitType type;
	private String name;
	private int troopCount;
	private boolean enemy;
	
	public Unit(UnitType type, String name, int troopCount) {
		this.type = type;
		this.name = name;
		this.troopCount = troopCount;
		this.enemy = false;
	}
	
	public boolean isEnemy() {	
		return this.enemy;
	}
	
	public void setEnemy() {
		this.enemy = true;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public UnitType getType() {
		return type;
	}
	
	public void setType(UnitType type) {
		this.type = type;
	}

	public int getTroopCount() {
		return troopCount;
	}
	
	public void setTroopCount(int troopCount) {
		this.troopCount = troopCount;
	}
	
	public double score(Unit enemy) {
		
		return troopCount * type.determineBattleScore(enemy.getType());
	}

	@Override
	public String toString() {
		return "Unit [type=" + type + ", name=" + name + ", troopCount="
				+ troopCount + ", enemy=" + enemy + "]";
	}
	
	public boolean isEliminated() {
		return (troopCount == 0) ? true : false;
	}
}

